// #autoload
// #name = madBlasterDrop
// #version = 0.4
// #status = beta
// #author = Monk
// #warrior = tao|Mad Monk
// #category = Monk's scripts
// #description = autodrop blaster
// #include = support/callback.cs
// #include = support/loadout.cs
// #include = support/bind_manager.cs
// #include = support/events.cs

if(isFile("prefs/madPrefs.cs") && !$madPrefsLoaded)
{
	exec("prefs/madPrefs.cs");
	$madPrefsLoaded = true;
}
else if(!$madPref::bdrop::loaded)
{
	// set defaults
	$madPref::bdrop::dropOnSpawn = true;
	$madPref::bdrop::alwaysDrop = true;
	$madPref::bdrop::loaded = true;
}

function madDropBlaster(%val)
{
	if(%val)
	{	
		throw("Blaster");
		use("Disc");
		$madBDropClear = schedule(300, 0, madClearBlaster);
	}
} // end function madDropBlaster
	
function madAutoDropBlaster()
{
	if($madPref::bdrop::dropOnSpawn)
		madDropBlaster(true);
}

function madPickupBlaster(%weapon)
{
	madDropBlaster(%weapon $= "Blaster" && $madPref::bdrop::alwaysDrop && $madPref::bdrop::dropOnSpawn);
}
	
function madClearBlaster()
{
	clientCmdSetWeaponsHudItem(0,0,0);
} // end function madClearBlaster
	
function madToggleBlaster(%val)
{
	if(%val)
	{
		$madPref::bdrop::dropOnSpawn = !$madPref::bdrop::dropOnSpawn;
		if($madPref::bdrop::dropOnSpawn)
		{
			addMessageHudLine("\c2o- Blaster Drop Enabled -o");
			madDropBlaster($madPref::bdrop::alwaysDrop);
		}
		else if(!$madPref::bdrop::dropOnSpawn)
		{
			addMessageHudLine("\c2o- Blaster Drop Disabled -o");
			cancel($madBDropClear);
		}
	}
} // end function madToggleBlaster

function madSavePrefs()
{		
	if(!$madPrefsSaved)
	{
		export("$madPref::*", "prefs/madPrefs.cs", false);			
		$madPrefsSaved = true;
	}
} // end prefs save
	
callback.add(PlayerSpawn, madAutoDropBlaster);
callback.add(WeaponReceived, madPickupBlaster);
callback.add(onQuit, madSavePrefs);

addMessageCallback('msgMissionStart', madAutoDropBlaster);

bindmanager.addbind("drop blaster", madDropBlaster);
bindmanager.addbind("toggle blaster drop", madToggleBlaster);
